/* Frame data decompiler */

/* lines are #clock:data-addr~scanline */

#include <stdio.h>

char *szReg[] = {
	"vsync","vblank","wsync","rsync","nusiz0","nusiz1","colup0","colup1",
	"colupf","colubk","ctrlpf","Refp0","Refp1","Pf0","Pf1","Pf2",
	"Resp0","Resp1","Resm0","Resm1","Resbl","Audc0","Audc1","Audf0",
	"Audf1","Audv0","Audv1","Grp0","Grp1","Enam0","Enam1","Enabl",
	"Hmp0","Hmp1","Hmm0","Hmm1","Hmbl","VDelp0","VDelp1","VDelbl",
	"Resmp0","Resmp1","HMove","HMClr","CxClr" };

static int nCSL = -1;

unsigned char cLine[4];

void main(int argc,char *argv[])
{
FILE *f = fopen(argv[1],"r");
FILE *fObj = fopen("g.out","w");
char szTemp[64],szBin[16];
int nClock,nAddr,nData,nScan,i,n;
if (f == NULL) exit(0);
while (fgets(szTemp,255,f) != NULL)
	{
	sscanf(szTemp+1,"%x",&nClock);
	sscanf(szTemp+4,"%x",&nData);
	sscanf(szTemp+7,"%x",&nAddr);
	sscanf(szTemp+10,"%x",&nScan);
	if (nScan != nCSL)
		{
		printf("On scan line %d...\n",nScan);
		if (nCSL != -1) fprintf(fObj,"   db 255,255,255,255\n");
		fprintf(fObj,";\n; Scan line %d\n;\n",nScan);
		fprintf(fObj,"dw  %d\n",nScan);
		nCSL = nScan;
		}
	n = nData;
	for (i = 7;i >= 0;i--)
		{
		szBin[i] = (n & 1) ? '1' : '0';
		n = n / 2;
		}
	szBin[8] = '\0';
	n = nClock * 3 - 68 + 5;
	if (n < 0) n = 0;
	printf("      @ %3d %3d Set %-6s to %3d %s\n",n,nClock,szReg[nAddr],nData,szBin);
	fprintf(fObj,"    db %d,%d,%d,%d\n",nClock,nAddr,nData,0);
	}
fclose(f);
fprintf(fObj,"   db 255,255,255,255\n   dw -1\n");
fclose(fObj);
}